package fos

// Note that TypeTree is distinct from Type.
// See comment on TypeTree to learn more.
enum Type:
  case TypeVar(name: String)
  case FunType(t1: Type, t2: Type)
  case NatType
  case BoolType
  
  override def toString() = this match
    case TypeVar(name) => name
    case FunType(t1, t2) => "(" + t1 + " -> " + t2 + ")"
    case NatType => "Nat"
    case BoolType => "Bool"

